//+------------------------------------------------------------------+
//|                                             eVOLution-levels.mq4 |
//|                Copyright  2010, someBody, trading-evolution.com |
//|                                 http://www.trading-evolution.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009-2010, someBody, trading-evolution.com"
#property link      "http://www.trading-evolution.com"

#property indicator_chart_window

#import

extern int NumberOfDaysBackToShow = 4;
extern double LevelsVerticalShift = 0;
extern string FileNamePruductCode  = "";
extern string separator = "-------------";
extern bool ReverseDataFromFile = false;
extern bool ShowKeyZone = True;
extern bool ShowMajorLevels = True;
extern bool ShowMajorCALLLevels = True;
extern bool ShowMajorPUTLevels = True;
extern color MajorCALLColor = Green;
extern color MajorPUTColor = Red;
extern color KeyZoneColor = SteelBlue;
extern color MajorLevelsColor = Gainsboro;
extern int MajorCALLStyle=0;
extern int MajorPUTStyle=0;



int FirstLevelWidth=1;
int correction=1;

string varray[50];
string currency,currency1;
string curmonth,nextmonth,curdate,curyear,nextyear;
bool cur,reverse;
int clevel1count,clevel2count;


//---- input parameters
int          corner=0;




double ExtMapBuffer1[];
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   cur=TRUE;
   NumberOfDaysBackToShow=NumberOfDaysBackToShow+1;
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   

//---- trying to indentify what file to load based on symbol
   currency =StringSubstr( Symbol(),0,2);
   currency1 = StringSubstr( Symbol(),0,6);
   
   if(currency=="6E" || currency1=="EURUSD")
   {currency = "ec";
   reverse=false;}
   else if(currency =="6B" || currency1=="GBPUSD")
   {currency = "bp";
   reverse=false;}
   else if(currency=="6J")
   {currency ="jy";
   reverse=false;}
   else if (currency1=="USDJPY")
   {currency ="jy";
   reverse=true;
   correction=100;}
   else if(currency == "6A" || currency1 == "AUDUSD")
   {currency ="ad";
   reverse=false;}
   else if(currency == "6C")
   {currency ="cd";
   reverse=false;}
   else if (currency1 =="USDCAD")
   {currency ="cd";
   reverse=true;
   correction=1;}
   else if(currency =="ES" || currency1 =="S&P_50")
   {currency = "es";
   reverse=false;}
   else{cur=FALSE;return(0);}

if (StringLen(FileNamePruductCode )>1) 
{currency = FileNamePruductCode ;
cur=true;
if (ReverseDataFromFile==true){
reverse=true;}
else {reverse=false;}

}

Print ("symbol_code is "+currency);



if(cur==FALSE){Alert("Product not recognized.");return(0);}



//----
   string filename,filename2, buff_str = "";
   int shft, handle,handle2, height, pointer, j, m;
   shft=10;
   int weekendshift=0;






for (j=0;j<NumberOfDaysBackToShow;j++)
{
m=TimeCurrent()-86400*j-86400*weekendshift;
//---- getting date data


if (TimeDayOfWeek(m)==0)
{weekendshift=2;
m=TimeCurrent()-86400*j-86400*weekendshift;}

else if (TimeDayOfWeek(m)==6)
{weekendshift=1;
m=TimeCurrent()-86400*j-86400*weekendshift;
}


if (TimeDay(m)<10){
curdate="0"+TimeDay(m);
}
else
{
curdate=TimeDay(m);
}

curyear=TimeYear(m);
nextyear=curyear;

if (TimeMonth(m)<10)
{curmonth="0"+TimeMonth(m);}
else
{curmonth=TimeMonth(m);}

if (TimeMonth(m)<=8)
{nextmonth="0"+(TimeMonth(m)+1);}
else if (TimeMonth(m)<12 && TimeMonth(m)>8)
{nextmonth=(TimeMonth(m)+1);}
else
{nextmonth="01";
nextyear=StrToInteger(curyear)+1;
}

curyear=StringSubstr(curyear,2,2);
nextyear=StringSubstr(nextyear,2,2);


//---- loading file

   filename = "/evolution-options/ol-"+curyear+curmonth+curdate+"-"+currency+"-"+curyear+curmonth+".csv";
   Print ("---> Filename "+filename);
   handle=FileOpen(filename, FILE_CSV|FILE_READ,",");
   
   //current month file opening problem
   if(handle<0)    
      {
      if(GetLastError()==4103)         
         {
         Print("No such file "+filename+" , trying next month contract period");
         filename = "/evolution-options/ol-"+curyear+curmonth+curdate+"-"+currency+"-"+nextyear+nextmonth+".csv";
         handle=FileOpen(filename, FILE_CSV|FILE_READ,",");
         Print (filename);
         
         
         //next month file opening problem
         if(handle<0)
            {
            if(GetLastError()==4103)
               {
               //Print("No such file "+filename);
               continue;
               }
            else                         
               {Print("Error opening file ");}
            }
      }
      else                       
         {Print("Error opening file ");}
     }
     
    
    int i=0;
     while ( !FileIsEnding(handle))
      {
      varray[i] = FileReadString(handle);
      i++;
      }

      FileClose( handle );


Print ("Go for it "+varray[0]);

//---------------------------------------------------------------

if (ShowKeyZone){
  drawArea("keyzone-"+j, varray[0] , StrToDouble(varray[1]) ,  StrToDouble(varray[2]), KeyZoneColor,0,0,FirstLevelWidth);
  }
  
if (ShowMajorLevels){
  drawLine("major1-"+j, "nothing" , varray[0] , StrToDouble(varray[3]), MajorLevelsColor,0,0,FirstLevelWidth);
  drawLine("major2-"+j, "nothing" , varray[0] , StrToDouble(varray[4]), MajorLevelsColor,0,0,FirstLevelWidth);
  }
if (ShowMajorCALLLevels){
  drawLine("call1-"+j, "nothing" , varray[0] , StrToDouble(varray[5]), MajorCALLColor,MajorCALLStyle,0,FirstLevelWidth);
  drawLine("call2-"+j, "nothing" , varray[0] , StrToDouble(varray[6]), MajorCALLColor,MajorCALLStyle,0,FirstLevelWidth);
  drawLine("call3-"+j, "nothing" , varray[0] , StrToDouble(varray[7]), MajorCALLColor,MajorCALLStyle,0,FirstLevelWidth);
  }
if (ShowMajorPUTLevels){
  drawLine("put1-"+j, "nothing" , varray[0] , StrToDouble(varray[8]), MajorPUTColor,MajorPUTStyle,0,FirstLevelWidth);
  drawLine("put2-"+j, "nothing" , varray[0] , StrToDouble(varray[9]), MajorPUTColor,MajorPUTStyle,0,FirstLevelWidth);
  drawLine("put3-"+j, "nothing" , varray[0] , StrToDouble(varray[10]), MajorPUTColor,MajorPUTStyle,0,FirstLevelWidth);
  }

}
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  int k;
      
for (k=0;k<NumberOfDaysBackToShow;k++){   
   ObjectDelete("keyzone-"+k);
   ObjectDelete("major1-"+k);
   ObjectDelete("major2-"+k);
   ObjectDelete("call1-"+k);
   ObjectDelete("call2-"+k);
   ObjectDelete("call3-"+k);
   ObjectDelete("put1-"+k);
   ObjectDelete("put2-"+k);
   ObjectDelete("put3-"+k); 
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----


   return(0);
   
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


//-----


void drawLine(string name, string dummy, string mydate, double price1, color col, int style, bool rayflag, int width)
{  


string time1=TimeToStr(StrToTime("20"+StringSubstr(mydate, 0, 2)+"."+StringSubstr(mydate, 2, 2)+"."+StringSubstr(mydate, 4, 2)+" 23:59"));
string time2=TimeToStr(StrToTime("20"+StringSubstr(mydate, 0, 2)+"."+StringSubstr(mydate, 2, 2)+"."+StringSubstr(mydate, 4, 2)+" 23:59")+86400);


if (TimeDayOfWeek(StrToTime(time1))==0) time1=TimeToStr(StrToTime(time1)+86400);
else if (TimeDayOfWeek(StrToTime(time1))==6) time1=TimeToStr(StrToTime(time1)+86400+86400);

if (TimeDayOfWeek(StrToTime(time2))==0) time2=TimeToStr(StrToTime(time2)+86400);
else if (TimeDayOfWeek(StrToTime(time2))==6) time2=TimeToStr(StrToTime(time2)+86400+86400);

if (reverse==true){
price1=correction*1/price1;

}

    if (ObjectFind(name) != 0) {
     ObjectDelete(name);
    } 
   ObjectCreate(name, OBJ_TREND, 0, StrToTime(time1), price1+LevelsVerticalShift, StrToTime(time2), price1+LevelsVerticalShift);
	ObjectSet(name, OBJPROP_COLOR, col);
	ObjectSet(name, OBJPROP_BACK, false);
	ObjectSet(name, OBJPROP_STYLE,style);
   ObjectSet(name, OBJPROP_RAY, rayflag);
   ObjectSet(name, OBJPROP_WIDTH, width);
           
}




void drawArea(string name, string mydate, double price1, double price2, color col, int style, bool rayflag, int width)
{  


string time1=TimeToStr(StrToTime("20"+StringSubstr(mydate, 0, 2)+"."+StringSubstr(mydate, 2, 2)+"."+StringSubstr(mydate, 4, 2)+" 23:59"));
string time2=TimeToStr(StrToTime("20"+StringSubstr(mydate, 0, 2)+"."+StringSubstr(mydate, 2, 2)+"."+StringSubstr(mydate, 4, 2)+" 23:59")+86400);

if (TimeDayOfWeek(StrToTime(time1))==0) time1=TimeToStr(StrToTime(time1)+86400);
else if (TimeDayOfWeek(StrToTime(time1))==6) time1=TimeToStr(StrToTime(time1)+86400+86400);

if (TimeDayOfWeek(StrToTime(time2))==0) time2=TimeToStr(StrToTime(time2)+86400);
else if (TimeDayOfWeek(StrToTime(time2))==6) time2=TimeToStr(StrToTime(time2)+86400+86400);

if (reverse==true){
price1=correction*1/price1;
price2=correction*1/price2;
}

    if (ObjectFind(name) != 0) {
     ObjectDelete(name);
    } 

   ObjectCreate(name, OBJ_RECTANGLE, 0, StrToTime(time1), price1+LevelsVerticalShift, StrToTime(time2), price2+LevelsVerticalShift);
	ObjectSet(name, OBJPROP_COLOR, col);
	ObjectSet(name, OBJPROP_BACK, true);
	ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSetText(name,"price2="+price2,10);
 
           
}